/*
 * University of Illinois/NCSA Open Source License
 *
 * Copyright (c) 2020-22, Advanced Micro Devices, Inc.
 * All rights reserved.
 *
 * Developed by:
 *
 *                 AMD Research and AMD Software Development
 *
 *                 Advanced Micro Devices, Inc.
 *
 *                 www.amd.com
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to
 * deal with the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 *  - Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimers.
 *  - Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimers in
 *    the documentation and/or other materials provided with the distribution.
 *  - Neither the names of <Name of Development Group, Name of Institution>,
 *    nor the names of its contributors may be used to endorse or promote
 *    products derived from this Software without specific prior written
 *    permission.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS WITH THE SOFTWARE.
 *
 */
#ifndef INCLUDE_E_SMI_E_SMI_UTILS_H_
#define INCLUDE_E_SMI_E_SMI_UTILS_H_

/** \file e_smi_utils.h
 *  Header file for the device specific file access.
 *
 *  @brief These functions holds the sysfs access helper functions for HSMP
 *  driver and Energy driver.
 *
 *  The sysfs path can be accessed by reading and writing using below APIs.
 */
int readsys_u32(char *filepath, uint32_t *pval);
int writesys_s32(char *filepath, int32_t val);
int writesys_u32(char *filepath, uint32_t val);
int readsys_u64(char *filepath, uint64_t *pval);
int readsys_str(char *filepath, char *pval, uint32_t val);
int readmsr_u64(char *filepath, uint64_t *pval, uint64_t reg);

#endif  // INCLUDE_E_SMI_E_SMI_UTILS_H_
